; This is a minimum test-proggy..........
; Reading 1 sector from a CDROM
; Communicating with SCSI and ATAPI CD-ROM devices via SPTI
; by: Siekmanski.

; Works on Windows 2000 Windows XP Windows Server 2003
; For Windows 95/98 SE and Windows ME we need ASPI
; I'll do that soon..... see you have fun. 

; You can find all info about "SCSI-3 Multimedia Commands (MMC)" at http://www.t10.org/drafts.htm

.486
.model FLAT,STDCALL
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include masm32.inc

includelib user32.lib
includelib kernel32.lib
includelib masm32.lib

TEXT_ MACRO your_text:VARARG
	LOCAL text_string
	.data
	 text_string db your_text,0
	.code
	EXITM <addr text_string>
ENDM

Copy_tekst MACRO karakters
	push	ecx
	mov 	ecx,karakters
	cld
	rep 	movsb
	xor 	eax,eax
	stosb
	pop		ecx
ENDM

CTL_CODE MACRO DevType:REQ,Function:REQ,Method:REQ,Access:REQ
    EXITM %(((DevType) shl 16) or ((Access) shl 14) or ((Function) shl 2) or (Method))
ENDM

METHOD_BUFFERED					equ 0
METHOD_IN_DIRECT				equ 1
METHOD_OUT_DIRECT				equ 2
METHOD_NEITHER					equ 3

FILE_ANY_ACCESS					equ 0
FILE_READ_ACCESS				equ 1
FILE_WRITE_ACCESS				equ 2

TimeOutValue					equ 20	;seconds


IOCTL_SCSI_BASE					equ	4
IOCTL_SCSI_PASS_THROUGH			TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0401h, METHOD_BUFFERED, FILE_READ_ACCESS or FILE_WRITE_ACCESS )
IOCTL_SCSI_MINIPORT				TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0402h, METHOD_BUFFERED, FILE_READ_ACCESS or FILE_WRITE_ACCESS )
IOCTL_SCSI_GET_INQUIRY_DATA		TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0403h, METHOD_BUFFERED, FILE_ANY_ACCESS )
IOCTL_SCSI_GET_CAPABILITIES		TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0404h, METHOD_BUFFERED, FILE_ANY_ACCESS )
IOCTL_SCSI_PASS_THROUGH_DIRECT	TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0405h, METHOD_BUFFERED, FILE_READ_ACCESS or FILE_WRITE_ACCESS )
IOCTL_SCSI_GET_ADDRESS			TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0406h, METHOD_BUFFERED, FILE_ANY_ACCESS )
IOCTL_SCSI_RESCAN_BUS			TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0407h, METHOD_BUFFERED, FILE_ANY_ACCESS )
IOCTL_SCSI_GET_DUMP_POINTERS	TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0408h, METHOD_BUFFERED, FILE_ANY_ACCESS )
IOCTL_SCSI_FREE_DUMP_POINTERS	TEXTEQU CTL_CODE( IOCTL_SCSI_BASE, 0409h, METHOD_BUFFERED, FILE_ANY_ACCESS )

SCSI_IOCTL_DATA_OUT				equ 0    ; Write
SCSI_IOCTL_DATA_IN				equ 1    ; Read
SCSI_IOCTL_DATA_UNSPECIFIED		equ 2    ; eject etc.

SENSE_LEN_SPTI					equ 32
SENSE_LEN                   	equ 14	; Default sense buffer length

KEY_NOSENSE						equ 0   ; No sense key info.
KEY_RECERROR					equ 1	; Recovered error. Last command completed successfully with some recovery action performed by the target.
KEY_NOTREADY					equ 2   ; Device not ready, Operator intervention may be required to correct this condition.
KEY_MEDIUMERR					equ 3	; Medium error. The command was terminated with a non-recoverable error condition.
KEY_HARDERROR					equ 4	; The drive detected a non-recoverable hardware failure.
KEY_ILLGLREQ					equ 5	; Illegal request or errors in parameters or cmd.
KEY_UNITATT						equ 6	; The drive may have been reset.
KEY_DATAPROT					equ 7	; Indicates that a command that reads or writes the medium was attempted on a block that is protected from this operation.
KEY_BLANKCHK					equ 8	; Indicates that a write-once device or a sequential-access device encountered blank medium or format-defined end-of-data indication while reading or a write-once device encountered a non-blank medium while writing.
KEY_VENDSPEC					equ 9	; Vendor specific sense key
KEY_COPYABORT					equ 10	; Indicates a COPY, COMPARE, or COPY AND VERIFY command was aborted due to an error condition on the source device, the destination device, or both.
KEY_ABORTED_COMMAND				equ 11	; The drive aborted the command.
KEY_EQUAL						equ 12	; obsolete
KEY_VOLOVRFLW					equ 13	; A buffered peripheral device has reached the end of medium partition and data remains in the buffer that has not been written to the medium.
KEY_MISCOMP						equ 14	; The source data did not match the data read from the medium.
KEY_RESERVED					equ 15	; Reserved 

STATUS_GOOD						equ 00h  ; Status Good
STATUS_CHKCOND					equ 02h  ; Check Condition
STATUS_CONDMET					equ	04h  ; Condition Met
STATUS_BUSY						equ 08h  ; Busy
STATUS_INTERM					equ 10h  ; Intermediate
STATUS_INTCDMET					equ 14h  ; Intermediate-condition met
STATUS_RESCONF					equ 18h  ; Reservation conflict
STATUS_COMTERM					equ 22h  ; Command Terminated
STATUS_QFULL					equ 28h  ; Queue full
STATUS_ACA						equ 30h  ; ACA active

CD_TYPE_CDDA_CDROM				equ 000h	
CD_TYPE_CD_I					equ 010h
CD_TYPE_CDROM_XA				equ 020h
CD_TYPE_UNDEFINED				equ 0FFh

CD_STATUS_EMPTY					equ 0
CD_STATUS_INCOMPLETE			equ 1
CD_STATUS_COMPLETE				equ 2
CD_STATUS_OTHERS				equ 3

CD_CAP_CDTEXT					equ 1	; CAPABILITY BITS if set == TRUE
CD_CAP_C2_ERRORS				equ 2
CD_CAP_READCD					equ 3
CD_CAP_LOCK						equ 4
CD_CAP_EJECT					equ 5
CD_CAP_TRAY						equ 6

_SCSI_PASS_THROUGH_DIRECT struct
    _Length				dw ?	;0
    ScsiStatus			db ?	;2
    PathId				db ?	;3
    TargetId			db ?	;4
    Lun					db ?	;5
    CdbLength			db ?	;6
    SenseInfoLength		db ?	;7
    DataIn				db ?	;8
	align 4		
    DataTransferLength	dd ?	;12  must be aligned on a double word boundary	
    TimeOutValue		dd ?	;16
    DataBuffer			dd ?	;20
    SenseInfoOffset		dd ?	;24
    Cdb					db 16 dup (?) ;28
_SCSI_PASS_THROUGH_DIRECT ends

SCSI_PASS_THROUGH_DIRECT typedef _SCSI_PASS_THROUGH_DIRECT

_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER struct
	sptd		SCSI_PASS_THROUGH_DIRECT <?>
	align 4		
	SenseBuffer	db SENSE_LEN_SPTI dup (?)
_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER ends

SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER typedef _SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER

_SCSI_ADDRESS struct
    _Length				dd ?	;0
    PortNumber			db ?	;4  == SCSI_Ha
    PathId				db ?	;5
    TargetId			db ?	;6
    Lun					db ?	;7
_SCSI_ADDRESS ends

SCSI_ADDRESS typedef _SCSI_ADDRESS

_TOC struct
	LBA					dd	?
	Minutes				db	?
	Seconds 			db	?
	Frames				db	?
	Flags				db	?
_TOC ends

TOC typedef _TOC

_CD_DVD_INFORMATION struct
	SCSI_PathId			db	?
	SCSI_Ha				db	?
	SCSI_Id				db	?
	SCSI_Lun			db	?
	SCSI_Drive			db	?
	Vendor_Id			db	8+1 dup (?)
	Product_Id			db	16+1 dup (?)
	Product_Revision	db	4+1 dup (?)
	CD_Handle			dd	?
	CAPS				dd	?
	Disk_Status			db	?
	Disk_Type			db	?
	Track_Count			dw	?
	TOC_Info			db	100*8 dup (?)
_CD_DVD_INFORMATION ends

CD_DVD_INFORMATION 		typedef _CD_DVD_INFORMATION

MAX_CD_DVD				equ	24
TOC_LBA					equ 0	; Time format for TOC
TOC_MSF					equ 2


.data

szHallo 			db "Siekmanski's SPTI CD-reader test 2006",13,10,13,10,0

szAspi_manager		db	"Aspi manager: " ;HA_ManagerId
Aspi_manager		db	20 dup	(0)
szSCSIAdapter_naam	db	"Adapter type: " ;HA_Identifier
SCSIAdapter_naam	db	20 dup	(0)


szDriveString		db	"\\.\"
DriveLetter			db	" :",0

LBA_sector			dd	150	; sector to read
 
.data?

	align 4		

TOC_Buffer			db	5000 dup (?) ;1024 dup (?)
SCSI_Buffer			db	1024 dup (?)
SCSI_DataBuffer 	db	2352+96 dup (?)

szAlbum_title		db	64 dup (?)
szArtist			db	64 dup (?)
szTrack_title		db	256 dup (?)

	align 4		

CommandDescriptor	dd	?
sptd_wb				SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER <>
SCSIaddress			SCSI_ADDRESS <?>
CD_Info				CD_DVD_INFORMATION MAX_CD_DVD dup (<?>)

CD_Count			dd	?
CD_Number			dd	?
CD_InfoPtr			dd	?
CD_Handle			dd	?

SCSI_Ha				db	?
SCSI_PathId			db	?
SCSI_Id				db	?
SCSI_Lun			db	?

szString_buffer		db	128 dup (?)

hFile			dd ?
dwWritebytes 	dd ?
.code


Check_Condition proc SenseBuffer:dword
LOCAL SenseKey:byte
LOCAL ASC:byte
LOCAL ASCQ:byte

	invoke	StdOut,TEXT_("CHECK SENSEKEY...",13,10)

	mov		ecx,SenseBuffer
	mov		al,[ecx+2]
	and		al,15
	mov		SenseKey,al
	mov		al,[ecx+12]
	mov		ASC,al
	mov		al,[ecx+13]
	mov		ASCQ,al

	.if 	SenseKey == KEY_NOSENSE
		invoke	StdOut,TEXT_("KEY_NOSENSE...",13,10)
		mov	eax,TRUE
		ret
	.elseif	SenseKey == KEY_RECERROR
		invoke	StdOut,TEXT_("KEY_RECERROR...",13,10)	
		mov	eax,TRUE
		ret
	.elseif	SenseKey == KEY_NOTREADY
		invoke	StdOut,TEXT_("KEY_NOTREADY...",13,10)
		.if	ASC == 3ah
			.if	ASCQ == 0
				invoke	StdOut,TEXT_("MEDIUM NOT PRESENT...",13,10)		
			.elseif ASCQ == 1
				invoke	StdOut,TEXT_("MEDIUM NOT PRESENT... TRAY CLOSED.",13,10)				
			.elseif ASCQ == 2
				invoke	StdOut,TEXT_("MEDIUM NOT PRESENT... TRAY OPEN.",13,10)					
			.endif
		mov	eax,FALSE
		ret
		.endif
	.elseif	SenseKey == KEY_ILLGLREQ
			invoke	StdOut,TEXT_("KEY_ILLGLREQ...",13,10)
		.if	ASC == 64h
			.if	ASCQ == 0
				invoke	StdOut,TEXT_("ILLEGAL MODE FOR THIS TRACK...",13,10)		
			.endif
		mov	eax,FALSE
		ret
		.endif
	.endif

	mov	eax,TRUE	
	ret
Check_Condition endp


InitSCSIcommand proc CdbLength:dword,DataBuffer:dword,DataBufferLength:dword,SenseInfoLength:dword,Flags:dword
	push	edi

	mov		edi,DataBuffer
	xor		eax,eax
	mov		ecx,DataBufferLength
	shr		ecx,2
	cld
	rep		stosd

	lea		edi,sptd_wb
	xor		eax,eax
	mov		ecx,sizeof SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER / 4
	cld
	rep		stosd

	mov		al,SCSI_PathId
	mov		sptd_wb.sptd.PathId,al
	mov		al,SCSI_Id
	mov		sptd_wb.sptd.TargetId,al
;	mov		sptd_wb.sptd.TargetId,1
	mov		al,SCSI_Lun
	mov		sptd_wb.sptd.Lun,al

	mov		sptd_wb.sptd._Length,sizeof SCSI_PASS_THROUGH_DIRECT
	mov		eax,CdbLength
	mov		sptd_wb.sptd.CdbLength,al
	mov		eax,Flags
	mov		sptd_wb.sptd.DataIn,al
	mov		eax,DataBufferLength
	mov		sptd_wb.sptd.DataTransferLength,eax
	mov		sptd_wb.sptd.TimeOutValue,TimeOutValue
	mov		eax,DataBuffer
	mov		sptd_wb.sptd.DataBuffer,eax

	.if SenseInfoLength
		mov		sptd_wb.sptd.SenseInfoOffset,sizeof SCSI_PASS_THROUGH_DIRECT
		mov		eax,SenseInfoLength
		mov		sptd_wb.sptd.SenseInfoLength,al
	.endif

	lea		eax,sptd_wb.sptd.Cdb
	mov		CommandDescriptor,eax

	pop		edi
	ret
InitSCSIcommand endp


SendSCSIcommand proc
local dwBytesReturned:dword

	invoke	DeviceIoControl,CD_Handle,IOCTL_SCSI_PASS_THROUGH_DIRECT,addr sptd_wb,sizeof sptd_wb,addr sptd_wb,sizeof sptd_wb,addr dwBytesReturned,NULL
 
   	.if (eax)
  		.if	sptd_wb.sptd.ScsiStatus == STATUS_CHKCOND
			invoke	Check_Condition,addr sptd_wb.SenseBuffer		
			ret
		.endif
		mov	eax,TRUE
		ret
	.else
		invoke	GetLastError
		invoke	wsprintf,addr szString_buffer,TEXT_("SCSIcommand Errorcode: %d",13,10,13,10),eax
		invoke	StdOut,addr szString_buffer
	.endif
	mov	eax,FALSE
	ret
SendSCSIcommand endp

GetSCSIaddress proc
local dwBytesReturned:dword

	lea		esi,SCSIaddress
	mov		[esi].SCSI_ADDRESS._Length,sizeof SCSI_ADDRESS
	mov		dword ptr [esi+4],0

	invoke	DeviceIoControl,CD_Handle,IOCTL_SCSI_GET_ADDRESS,NULL,0,esi,sizeof SCSI_ADDRESS,addr dwBytesReturned,NULL

   	.if (eax)
		mov	eax,TRUE
		ret
	.else
		invoke	GetLastError
		invoke	wsprintf,addr szString_buffer,TEXT_("SCSIaddress Errorcode: %d",13,10,13,10),eax
		invoke	StdOut,addr szString_buffer
	.endif
	mov	eax,FALSE
	ret
GetSCSIaddress endp

CD_Init proc number:dword
	push	esi
	lea		esi,CD_Info
	mov		eax,number
	mov		ecx,sizeof CD_DVD_INFORMATION
	mul		ecx
	add		esi,eax
	mov		cl,[esi].CD_DVD_INFORMATION.SCSI_Ha
	mov		SCSI_Ha,cl	
	mov		cl,[esi].CD_DVD_INFORMATION.SCSI_PathId
	mov		SCSI_PathId,cl
	mov		cl,[esi].CD_DVD_INFORMATION.SCSI_Id
	mov		SCSI_Id,cl
	mov		cl,[esi].CD_DVD_INFORMATION.SCSI_Lun
	mov		SCSI_Lun,cl
	mov		cl,[esi].CD_DVD_INFORMATION.SCSI_Drive
	mov		DriveLetter,cl
	mov		ecx,[esi].CD_DVD_INFORMATION.CD_Handle
	mov		CD_Handle,ecx
	mov		eax,esi	; return pointer to cd infos
	pop		esi
	ret
CD_Init endp



CDROM_Name proc
	invoke	InitSCSIcommand,6,addr SCSI_Buffer,100,SENSE_LEN_SPTI,SCSI_IOCTL_DATA_IN

	mov		eax,CommandDescriptor
	mov		byte ptr [eax+0],012h 	; SCSI_INQUIRY
	mov		byte ptr [eax+4],100

	invoke	SendSCSIcommand
	ret
CDROM_Name endp


GetDeviceCapabilities proc
LOCAL	shift_value:dword

	mov		shift_value,0
		
	invoke	InitSCSIcommand,12,addr SCSI_Buffer,16,SENSE_LEN_SPTI,SCSI_IOCTL_DATA_IN

	mov		eax,CommandDescriptor
	mov		byte ptr [eax+0],046h 	; get configuration
	mov		byte ptr [eax+3],01eh 	; cd read features
	mov		byte ptr [eax+8],16		; return 16 bytes

	invoke	SendSCSIcommand
   	.if (eax)		
		lea		esi,SCSI_Buffer + 8
		movzx	eax,byte ptr [esi+4]
		and		eax,11b	; bit 1 set == support CD-TEXT
						; bit 2 set == support C2 error pointers
		add		[edi].CD_DVD_INFORMATION.CAPS,eax
		add		shift_value,2
	.endif
	
	invoke	InitSCSIcommand,12,addr SCSI_Buffer,128,SENSE_LEN_SPTI,SCSI_IOCTL_DATA_IN

	mov		eax,CommandDescriptor
	mov		byte ptr [eax],05ah		; modesense
	mov		byte ptr [eax+2],02ah	; CDROM Capabilities and Mechanical Status Page
	mov		byte ptr [eax+8],128	; return 128 bytes

	invoke	SendSCSIcommand
   	.if (eax)		
		lea		esi,SCSI_Buffer + 8
		movzx	eax,byte ptr [esi+5]
		and		eax,1b		; bit set == support READ CD command
		mov		ecx,shift_value
		shl		eax,cl
		add		[edi].CD_DVD_INFORMATION.CAPS,eax
		add		shift_value,1

		movzx	eax,byte ptr [esi+6]
		and		eax,1b		; bit set == support LOCK command
		mov		ecx,shift_value
		shl		eax,cl
		add		[edi].CD_DVD_INFORMATION.CAPS,eax
		add		shift_value,1

		movzx	eax,byte ptr [esi+6]
		shr		eax,3		; get bit 3
		and		eax,1b		; bit set == support EJECT
		mov		ecx,shift_value
		shl		eax,cl
		add		[edi].CD_DVD_INFORMATION.CAPS,eax
		add		shift_value,1

		movzx	eax,byte ptr [esi+6]
		shr		eax,5		; get bit 5
		and		eax,1b		; bit set == TRAY else CADDY
		mov		ecx,shift_value
		shl		eax,cl
		add		[edi].CD_DVD_INFORMATION.CAPS,eax
		add		shift_value,1
	.endif
	
	ret

GetDeviceCapabilities endp

GetDiskInformation proc
	invoke	InitSCSIcommand,12,addr SCSI_Buffer,128,SENSE_LEN_SPTI,SCSI_IOCTL_DATA_IN

	mov		eax,CommandDescriptor
	mov		byte ptr [eax+0],051h 	; Read disk information
	mov		byte ptr [eax+8],128	; return 128 bytes

	invoke	SendSCSIcommand
   	.if (eax)		
		mov		edi,CD_InfoPtr
		lea		esi,SCSI_Buffer + 8
		mov		al,[esi+2] ; disk status
		and		al,11b
		mov		[edi].CD_DVD_INFORMATION.Disk_Status,al
		mov		ah,[esi+8] ; disk type
		mov		[edi].CD_DVD_INFORMATION.Disk_Type,al
	.endif
	ret
GetDiskInformation endp


CloseCDrom proc
	.if	CD_Count != 0
		lea		esi,CD_Info	
Close_CDHandles:
		mov		eax,[esi].CD_DVD_INFORMATION.CD_Handle
		mov		CD_Handle,eax
		.if	(CD_Handle != NULL)
			invoke	CloseHandle,CD_Handle
			mov		CD_Handle,NULL
			mov		al,[esi].CD_DVD_INFORMATION.SCSI_Drive	
			mov		DriveLetter,al
			invoke	wsprintf,addr szString_buffer,TEXT_(13,10,"CD/DVD at drive %s Closed...",13,10),addr DriveLetter
			invoke	StdOut,addr szString_buffer
		.endif
		add		esi,sizeof CD_DVD_INFORMATION
		dec		CD_Count
		jnz		Close_CDHandles
	.endif
	ret
CloseCDrom endp

OpenCDrom proc
	mov	CD_Handle,NULL
	invoke	CreateFile,addr szDriveString,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	mov	CD_Handle,eax
	.if	eax == INVALID_HANDLE_VALUE
		invoke	CreateFile,addr szDriveString,GENERIC_READ,FILE_SHARE_READ or FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
		mov	CD_Handle,eax
			.if	eax == INVALID_HANDLE_VALUE
				mov	CD_Handle,NULL
				invoke	wsprintf,addr szString_buffer,TEXT_("Cannot open CD/DVD at drive %s ...",13,10,13,10),addr DriveLetter
				invoke	StdOut,addr szString_buffer
			.endif
	.endif
	ret    
OpenCDrom endp


Find_cdroms proc
local DriveNumber:dword

	push	esi
	push	edi
	push	ebx

	mov		CD_Count,0

	lea		edi,CD_Info
	lea		ebx,DriveNumber
	mov		dword ptr [ebx],05C3A43h   ; "C:\",0
	.while	byte ptr [ebx] <= "Z"
		invoke GetDriveType,ebx
		.if	eax == DRIVE_CDROM
			mov	eax,[ebx]
			mov	byte ptr [edi].CD_DVD_INFORMATION.SCSI_Drive,al
			inc	CD_Count
			add	edi,sizeof CD_DVD_INFORMATION
      .endif
		inc byte ptr [ebx]
	.endw

	lea		edi,CD_Info
	mov		DriveNumber,0
get_cd_info:
	mov		al,[edi].CD_DVD_INFORMATION.SCSI_Drive	
	mov		DriveLetter,al
	invoke	OpenCDrom
	mov		eax,CD_Handle
	mov		[edi].CD_DVD_INFORMATION.CD_Handle,eax

	.if		(eax)

		invoke	GetSCSIaddress
		lea		esi,SCSIaddress
		mov		al,[esi].SCSI_ADDRESS.PortNumber
		mov		[edi].CD_DVD_INFORMATION.SCSI_Ha,al
		mov		al,[esi].SCSI_ADDRESS.PathId
		mov		[edi].CD_DVD_INFORMATION.SCSI_PathId,al
		mov		al,[esi].SCSI_ADDRESS.TargetId
		mov		[edi].CD_DVD_INFORMATION.SCSI_Id,al
		mov		al,[esi].SCSI_ADDRESS.Lun
		mov		[edi].CD_DVD_INFORMATION.SCSI_Lun,al

		invoke	CDROM_Name
		lea		esi,SCSI_Buffer + 8
		push	edi
		lea		edi,[edi].CD_DVD_INFORMATION.Vendor_Id
		Copy_tekst 8
		Copy_tekst 16
		Copy_tekst 4
		pop		edi

		invoke	GetDeviceCapabilities

	.endif

	add		edi,sizeof CD_DVD_INFORMATION
	inc		DriveNumber
	mov		eax,DriveNumber
	cmp		eax,CD_Count
	jb		get_cd_info

	invoke	wsprintf,addr Aspi_manager,TEXT_("SIEKMANSKI SPTI32")
	invoke	wsprintf,addr SCSIAdapter_naam,TEXT_("SCSI adapter")

	pop		ebx
	pop		edi
	pop		esi

	invoke	CD_Init,0

	ret
Find_cdroms endp

TestUnitReady proc

	invoke	InitSCSIcommand,6,NULL,0,SENSE_LEN_SPTI,SCSI_IOCTL_DATA_UNSPECIFIED
	mov		eax,CommandDescriptor
	mov		byte ptr [eax+0],0	;  test unit ready
	invoke	SendSCSIcommand
	.if		(!eax)
		invoke	StdOut,TEXT_("CD/DVD not ready...",13,10)
		mov		eax,FALSE
		ret
	.endif
	ret
TestUnitReady endp

ReadTocPmaAtip proc Format:dword,Time:dword,DataBuffer:dword,DataBufferLength:dword

	invoke	InitSCSIcommand,10,DataBuffer,DataBufferLength,SENSE_LEN_SPTI,SCSI_IOCTL_DATA_IN
	mov		eax,CommandDescriptor
	mov		byte ptr [eax+0],043h	;  READ TOC/PMA/ATIP command
	mov		ecx,Time
	mov		byte ptr [eax+1],cl		;  000h = LBA, 002h = MSF
	mov		ecx,Format
	mov		byte ptr [eax+2],cl	 	;  format 0 = TOC 1 = Session Info 2 = Full TOC 3 = PMA 4 = ATIP 5 = CD-TEXT
	mov		ecx,DataBufferLength
	mov		byte ptr [eax+7],ch
	mov		byte ptr [eax+8],cl
	
	invoke	SendSCSIcommand
	ret
ReadTocPmaAtip endp

ReadSector proc Sector:DWORD

	invoke	InitSCSIcommand,12,addr SCSI_DataBuffer,2352,SENSE_LEN_SPTI,SCSI_IOCTL_DATA_IN
	mov		eax,CommandDescriptor
	mov		byte ptr [eax+0],0beh 	; read cd
	mov		byte ptr [eax+1],100b 	; Only audio
	mov		ecx,Sector
	bswap	ecx
	mov		dword ptr [eax+2],ecx 
	mov		byte ptr [eax+8],1	; 1 logical block
	mov		byte ptr [eax+9],11111000b	;read 2352 bytes
	mov		byte ptr [eax+10],0	; No sub-channel data

	invoke	SendSCSIcommand
	ret
ReadSector endp


GetCDTEXT_string proc packs:dword,pack_definition:dword,track_number:dword,cd_string

	push	edi
	lea		esi,SCSI_Buffer + 4
	mov		edi,cd_string
 	mov		eax,pack_definition
 	mov		ecx,track_number
	mov		ah,cl
 	mov		ecx,packs
find_definition:
 	cmp		[esi],ax
	je		copy_string
	add		esi,18
	dec		ecx
	jnz		find_definition
	cmp		track_number,0
	jz		nothing_found
							; string must be shorter than 12 bytes	
	inc		track_number
	lea		esi,SCSI_Buffer + 4
 	mov		eax,pack_definition
 	mov		ecx,track_number
	mov		ah,cl
 	mov		ecx,packs
find_definition2:
 	cmp		[esi],ax
	je		copy_string2
	add		esi,18
	dec		ecx
	jnz		find_definition2
	jmp		nothing_found

copy_string2:
	sub		esi,18
	mov		ecx,16
find_null:				; search back from next track till second null byte found
	dec		ecx
	mov		al,[esi+ecx]
	cmp		al,0
	jnz		find_null
find_null2:	
	dec		ecx
	mov		al,[esi+ecx-1]
	cmp		al,0
	jnz		find_null2
	jmp		string_lp

copy_string:
	mov		ecx,4
	movzx	eax,byte ptr [esi+3]
	and		eax,1111b		; Character Position
	jz		string_lp
	sub		esi,18
	mov		ecx,16
	sub		ecx,eax
string_lp:
	mov		al,[esi+ecx]
	mov		[edi],al
	cmp		al,0
	jz		string_end
	inc		edi
	inc		ecx
	cmp		ecx,16
	jnz		string_lp
	add		esi,18
	mov		ecx,4
	jmp		string_lp
string_end:
	pop		edi
	mov		eax,TRUE
	ret

nothing_found:
	mov		dword ptr [edi],02d2d2dh
	pop		edi
	mov		eax,FALSE
	ret
GetCDTEXT_string endp


GetCDTEXT proc
LOCAL d1:dword
LOCAL d2:dword
LOCAL d3:dword
LOCAL d4:dword
LOCAL d5:dword
LOCAL aantal:dword
LOCAL teller:dword
LOCAL data_lengte:dword
LOCAL aantal_packs:dword

;CD-TEXT Pack Data format for the Lead-in area:
;
;byte 0 -> ID1  80h - 8fh ( Pack definitions )
;byte 1 -> ID2  0h = Album names, 1h - 63h Track titles  ; bit 7 is only set for extended applications
;byte 2 -> ID3  Sequence Number Indicator ( pack number 0h - FFh ( 255 packs in 1 block ))
;byte 3 -> ID4  Block Number and Character Position Indicator:
;               bit 0-3 = Character Position ; number of the character in the string that belongs to the Text Data Field in the previous pack
;               bit 4-6 = Block Number ; to wich pack it belongs ( up to 8 languages )
;               bit 7    = DBCC ; if set double byte character code
;byte 4 - 15 -> Text Data Field ( 12 ascii character bytes )
;byte 16 ->  CRC Field byte 0 or Reserved
;byte 17 ->  CRC Field byte 1 or Reserved
;
;Pack definitions:
;80h: Title of Album name ( if ID2 = 0h )
;        Track titles               ( if ID2 = 1h - 63h )
;81h: Name(s) of the performer(s) ( if ID2 = 0h : Album, 1h - 63h = track )
;82h: Name(s) of the songwriter(s) ( if ID2 = 0h : Album, 1h - 63h = track )
;83h: Name(s) of the composer(s) ( if ID2 = 0h : Album, 1h - 63h = track )
;84h: Name(s) of the arranger(s) ( if ID2 = 0h : Album, 1h - 63h = track )
;85h: Message(s) from content provider and/or artist
;86h: Disc Identification information
;87h: Genre Identification Genre information
;88h: Table of Content information
;89h: Second Table of Content information
;8Ah - 8Ch: Reserved
;8Dh: Reserved for content provider only
;8Eh: UPC/EAN code of the album and ISRC code of each track
;8Fh: Size information of the Block
;
;Packs with 86H - 89H and 8Fh contains binary information in the Text Data Field.
;
;The size of a character string is recommended to be less than 160 bytes.
;If a character string does not fit in a Text Data Field of a Pack, it is continued onto the succeeding Packs.
;The succeeding character string shall be encoded starting at the next byte in the Text Data Field after
;the terminator of the current string.
;Unused bytes in the Text Data Field  shall be filled with null codes.
;
;In case the same character string is used for consecutive tracks, the Tab-indicator may be used to indicate
;the same as previous track. It is a single tab code (09H) for single byte codes and two tab codes for double
;bytes character codes. (not used in the first track) 

	mov		edi,CD_InfoPtr
	test	[edi].CD_DVD_INFORMATION.CAPS,CD_CAP_CDTEXT
	.if	(!eax)
		invoke	StdOut,TEXT_("CD-TEXT not supported...",13,10,13,10)
		mov		eax,FALSE
		ret		
	.endif
	
	invoke	ReadTocPmaAtip,5,0,addr SCSI_Buffer,sizeof SCSI_Buffer

	lea		esi,SCSI_Buffer
	movzx	eax,byte ptr [esi+1]	; length of returned data
	mov		ah,byte ptr [esi+0]
	mov		data_lengte,eax

	.if	(eax <= 2)
		invoke	StdOut,TEXT_("CD-TEXT not found on CD..",13,10,13,10)
		mov		eax,FALSE
	.else

	mov		eax,data_lengte	; CDTEXT Data lengte / 18
	sub		eax,2
	mov		ecx,18
	xor		edx,edx
	div		ecx
	mov		aantal_packs,eax

	invoke	wsprintf,addr szString_buffer,TEXT_("CD-TEXT:",13,10,13,10)
	invoke	StdOut,addr szString_buffer
	invoke	wsprintf,addr szString_buffer,TEXT_("CDTEXT Data length: %d bytes",13,10,13,10),data_lengte
	invoke	StdOut,addr szString_buffer

	invoke	GetCDTEXT_string,aantal_packs,81h,0,addr szArtist

	invoke	wsprintf,addr szString_buffer,TEXT_("%s.txt"),addr szArtist

	mov		hFile,0
	invoke	CreateFile,addr szString_buffer,GENERIC_WRITE,FILE_SHARE_READ,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL
	inc		eax
	.if	(eax)
		dec	eax
		mov		hFile,eax
	.endif
		
	invoke	wsprintf,addr szString_buffer,TEXT_("Album Artist: %s",13,10),addr szArtist
	invoke	StdOut,addr szString_buffer

	.if (hFile)
		invoke	lstrlen,addr szString_buffer
		invoke  WriteFile,hFile,addr szString_buffer,eax,addr dwWritebytes,NULL
	.endif
	
	invoke	GetCDTEXT_string,aantal_packs,80h,0,addr szAlbum_title
	invoke	wsprintf,addr szString_buffer,TEXT_("Album Title : %s",13,10,13,10),addr szAlbum_title
	invoke	StdOut,addr szString_buffer

	.if (hFile)
		invoke	lstrlen,addr szString_buffer
		invoke  WriteFile,hFile,addr szString_buffer,eax,addr dwWritebytes,NULL
	.endif

	mov		edi,CD_InfoPtr
	movzx	eax,[edi].CD_DVD_INFORMATION.Track_Count
	mov		aantal,eax
	mov		teller,0
lees_track_titles:
	inc		teller
	invoke	GetCDTEXT_string,aantal_packs,80h,teller,addr szTrack_title
	invoke	wsprintf,addr szString_buffer,TEXT_("Track %2d : %s",13,10),teller,addr szTrack_title
	invoke	StdOut,addr szString_buffer

	.if (hFile)
		invoke	lstrlen,addr szString_buffer
		invoke  WriteFile,hFile,addr szString_buffer,eax,addr dwWritebytes,NULL
	.endif

	dec		aantal
	jnz		lees_track_titles
	

	invoke	wsprintf,addr szString_buffer,TEXT_(13,10,"CD-TEXT Raw dump:",13,10,13,10)
	invoke	StdOut,addr szString_buffer

	.if (hFile)
		invoke	lstrlen,addr szString_buffer
		invoke  WriteFile,hFile,addr szString_buffer,eax,addr dwWritebytes,NULL
	.endif
	

dump_RAW_CDText:
	lea		esi,SCSI_Buffer
	mov		eax,data_lengte	; CDTEXT Data lengte / 18
	sub		eax,2
	mov		ecx,18
	xor		edx,edx
	div		ecx
;	inc		eax		; 1 extra voor een lege regel
	mov		aantal,eax
	add		esi,4
tellen:
	mov		eax,[esi+0]
	bswap	eax
	mov		d1,eax
	mov		eax,[esi+4]
	bswap	eax
	mov		d2,eax
	mov		eax,[esi+8]
	bswap	eax
	mov		d3,eax
	mov		eax,[esi+12]
	bswap	eax
	mov		d4,eax
	
	movzx	eax,byte ptr [esi+17]
	mov		ah,byte ptr [esi+16]
	mov		d5,eax

	invoke	wsprintf,addr szString_buffer,TEXT_(" %08xH %08xH %08xH %08xH %04xH",13,10),d1,d2,d3,d4,d5
	invoke	StdOut,addr szString_buffer

	.if (hFile)
		invoke	lstrlen,addr szString_buffer
		invoke  WriteFile,hFile,addr szString_buffer,eax,addr dwWritebytes,NULL
	.endif

	add		esi,18
	dec		aantal
	jnz		tellen
	mov		eax,TRUE


	.if	(hFile)
		invoke  CloseHandle,hFile
		invoke	StdOut,TEXT_("CD-TEXT dump written...",13,10,13,10)
	.endif


	.endif

	ret
GetCDTEXT endp

GetTOCinfo proc
local	Track_Total:dword

	invoke	ReadTocPmaAtip,0,TOC_LBA,addr SCSI_Buffer,sizeof SCSI_Buffer

	lea		esi,SCSI_Buffer
	mov		edi,CD_InfoPtr
	
	movzx	eax,byte ptr [esi+2]
	movzx	ecx,byte ptr [esi+3]
	inc		ecx
	sub		ecx,eax
	mov		Track_Total,ecx
	mov		[edi].CD_DVD_INFORMATION.Track_Count,cx
	lea		edi,[edi].CD_DVD_INFORMATION.TOC_Info
	add		esi,4	

track_info:
	mov		ecx,dword ptr [esi+4]
	bswap	ecx
	mov		[edi].TOC.LBA,ecx
	mov		eax,dword ptr [esi+4+8]
	bswap	eax
	sub		eax,ecx
	mov		ecx,75*60
	xor		edx,edx
	div		ecx
	mov		[edi].TOC.Minutes,al
	mov		eax,edx
	mov		ecx,75
	xor		edx,edx
	div		ecx
	mov		[edi].TOC.Seconds,al
	mov		[edi].TOC.Frames,dl
	mov		al,[esi+1]
	mov		[edi].TOC.Flags,al

	add		esi,8
	add		edi,8
	dec		Track_Total
	jnz		track_info

	mov		eax,dword ptr [esi+4] ; total time	
	bswap	eax
	mov		[edi].TOC.LBA,eax			
	mov		ecx,75*60
	xor		edx,edx
	div		ecx
	mov		[edi].TOC.Minutes,al
	mov		eax,edx
	mov		ecx,75
	xor		edx,edx
	div		ecx
	mov		[edi].TOC.Seconds,al
	mov		[edi].TOC.Frames,dl
	ret
GetTOCinfo endp



ShowTOC proc
local	Track_Total:dword
local 	track_nummer:dword
LOCAL	LBA_start:dword
local 	minuten:dword
local 	seconden:dword
local 	frames:dword
local 	track_attributes:dword
local 	subchannel_Q:dword
local 	audio_bit:dword
local 	copy_bit:dword

	mov		track_nummer,1
	mov		esi,CD_InfoPtr
	movzx	eax,[esi].CD_DVD_INFORMATION.Track_Count
	mov		Track_Total,eax
	lea		esi,[esi].CD_DVD_INFORMATION.TOC_Info

	invoke	wsprintf,addr szString_buffer,TEXT_("Track Total: %d",13,10,13,10),Track_Total
	invoke	StdOut,addr szString_buffer

ShowTracks:	
	mov		eax,[esi].TOC.LBA
	mov		LBA_start,eax

	movzx	eax,[esi].TOC.Minutes
	mov		minuten,eax
	movzx	eax,[esi].TOC.Seconds
	mov		seconden,eax
	movzx	eax,[esi].TOC.Frames
	mov		frames,eax

	movzx	eax,[esi].TOC.Flags
	mov		ecx,eax
	and		eax,0fh
	mov		track_attributes,eax	
	shr		ecx,4
	mov		subchannel_Q,ecx

;	track attributes:
;
;	00x0b	2 audio channels without pre-emphasis
;	00x1b	2 audio channels with pre-emphasis
;	10x0b	  audio channels without pre-emphasis cd-r/rw
;	10x1b	  audio channels with pre-emphasis cd-r/rw
;	01x0b	data track, recorded uninterrupted
;	01x1b	data track, recorded incremental
;	xx0xb	digital copy prohibited
;	xx0xb	digital copy permitted
;
;	if bit 3 = 1 -> data track
;	if bit 3 = 0 -> audio track

;	Q Sub-channel
;
;	0	Q Sub-channel mode information not supplied
;	1	Q Sub-channel mode encodes current position data
;	2	Q Sub-channel mode encodes media catalog number
;	3	Q Sub-channel mode encodes ISRC


	lea		ecx,copy_bit
	test	eax,0010b	;check copybit
	jz		prohibited
	mov		dword ptr [ecx],0534559h  ; "YES",0
	jmp		check_audio
prohibited:	
	mov		dword ptr [ecx],0204F4Eh    ; "NO",0	
check_audio:	
	lea		ecx,audio_bit
	test	eax,0100b	;check data format
	jnz		data_track
	mov		dword ptr [ecx],0534559h  ; "YES",0
	jmp		check_done
data_track:
	mov		dword ptr [ecx],0204F4Eh    ; "NO",0	
check_done:
	
	invoke	wsprintf,addr szString_buffer,TEXT_("Track:%2d LBA:%6d %2d:%02d:%02d  Audio: %s Copy permitted: %s Qsub-chan: %d",13,10),\
			track_nummer,LBA_start,minuten,seconden,frames,addr audio_bit,addr copy_bit,subchannel_Q
	invoke	StdOut,addr szString_buffer

	inc		track_nummer
	add		esi,8
	dec		Track_Total
	jnz		ShowTracks

	mov		eax,[esi].TOC.LBA
	mov		LBA_start,eax

	movzx	eax,[esi].TOC.Minutes
	mov		minuten,eax
	movzx	eax,[esi].TOC.Seconds
	mov		seconden,eax
	movzx	eax,[esi].TOC.Frames
	mov		frames,eax

	invoke	wsprintf,addr szString_buffer,TEXT_(13,10,"LBA:%6d Total time %2d:%02d:%02d",13,10,13,10),LBA_start,minuten,seconden,frames
	invoke	StdOut,addr szString_buffer

	ret

ShowTOC endp

start:
	invoke	StdOut,addr szHallo

	invoke	Find_cdroms

	cmp		CD_Count,0
	jnz		CDrom_gevonden
	invoke	StdOut,TEXT_("No CD-Roms found...",13,10)
	jmp		sluit_prog
CDrom_gevonden:
	
	mov		eax,CD_Count
	invoke	wsprintf,addr szString_buffer,TEXT_("CD-Roms found: %d",13,10,13,10),eax
	invoke	StdOut,addr szString_buffer

	mov		CD_Number,0	; choose cd/dvd-rom to work with ( the first one found == 0)
	invoke	CD_Init,CD_Number
	mov		CD_InfoPtr,eax

;	invoke	wsprintf,addr szString_buffer,TEXT_("waarde: %xH",13,10,13,10),0
;	invoke	StdOut,addr szString_buffer

	invoke	wsprintf,addr szString_buffer,TEXT_("%s",13,10,"%s",13,10,13,10),addr szAspi_manager,addr szSCSIAdapter_naam
	invoke	StdOut,addr szString_buffer
	
	movzx	eax,SCSI_Ha		
	movzx	ecx,SCSI_Id		
	movzx	edx,SCSI_Lun		
	invoke	wsprintf,addr szString_buffer,TEXT_("SCSI-INFO   : Ha:%d Id:%d Lun:%d",13,10),eax,ecx,edx
	invoke	StdOut,addr szString_buffer

	mov		esi,CD_InfoPtr
	lea		eax,[esi].CD_DVD_INFORMATION.Vendor_Id
	lea		ecx,[esi].CD_DVD_INFORMATION.Product_Id
	lea		edx,[esi].CD_DVD_INFORMATION.Product_Revision
	invoke	wsprintf,addr szString_buffer,TEXT_("CD/DVD-INFO : %s\ %s %s %s",13,10,13,10),addr DriveLetter,eax,ecx,edx
	invoke	StdOut,addr szString_buffer


	mov		eax,CD_InfoPtr
	mov		eax,[eax].CD_DVD_INFORMATION.CAPS
	invoke	wsprintf,addr szString_buffer,TEXT_("DeviceCapabilities: %xH",13,10,13,10),eax
	invoke	StdOut,addr szString_buffer


	invoke	TestUnitReady
	invoke	GetDiskInformation

	invoke	GetTOCinfo
	invoke	ShowTOC
	
	invoke	GetCDTEXT

;	invoke	ReadSector,LBA_sector

;   	.if (eax)		
;		invoke	StdOut,TEXT_("SendSCSIcommand OK !",13,10,13,10)
;		lea	eax,SCSI_DataBuffer
;		mov	eax,[eax]
;		invoke	wsprintf,addr szString_buffer,TEXT_("First DWORD read from LBA_sector: %d = %xH",13,10,13,10),LBA_sector,eax
;		invoke	StdOut,addr szString_buffer
;	.endif


sluit_prog:	
	invoke	CloseCDrom
	invoke	Sleep,100000

	invoke	ExitProcess,0
end start